Subject: Re: [PATCH 0/8] ARM crc64 and XOR using NEON intrinsics

From: Eric Biggers <[email-masked]>
Date: Thu, 28 May 2026 13:35:08 -0700

On Wed, Apr 22, 2026 at 07:16:56PM +0200, Ard Biesheuvel wrote:
> From: Ard Biesheuvel <[email-masked]>
> 
> This is a follow-up to both [0] and [1], both of which included patch #1
> of this series, which introduces the asm/neon-intrinsics.h header on
> 32-bit ARM. The remaining changes rely on this.
> 
> The purpose of this series is to streamline / clean up the use of NEON
> intrinsics on 32-bit ARM, by sharing more code, clean up Make rules and
> finally, getting rid of the hacked up types.h header, which does some
> nasty things that are only needed when building NEON intrinsics code.
> 
> Patches #2 and #3 replace the ARM autovectorized XOR implementation with
> the NEON intrinsics version used by arm64.
> 
> Patches #4 and #5 enable the arm64 NEON intrinsics implementation of
> crc64 on 32-bit ARM.
> 
> Patches #6 and #7 drop the direct includes of <arm_neon.h> and perform
> some additional cleanup to reduce the delta between ARM and arm64 code
> and Make rules.
> 
> It would probably be easiest to take all these changes through a single
> tree, and the CRC tree seems like a suitable candidate, if Eric agrees.
> 
> Cc: Christoph Hellwig <[email-masked]>
> Cc: Russell King <[email-masked]>
> Cc: Arnd Bergmann <[email-masked]>
> Cc: Eric Biggers <[email-masked]>
> 
> [0] https://lore.kernel.org/all/[email-masked]/
> [1] https://lore.kernel.org/all/[email-masked]/
> 
> Ard Biesheuvel (8):
>   ARM: Add a neon-intrinsics.h header like on arm64
>   xor/arm: Replace vectorized implementation with arm64's intrinsics
>   xor/arm64: Use shared NEON intrinsics implementation from 32-bit ARM
>   lib/crc: Turn NEON intrinsics crc64 implementation into common code
>   lib/crc: arm: Enable arm64's NEON intrinsics implementation of crc64
>   crypto: aegis128 - Use neon-intrinsics.h on ARM too
>   lib/raid6: Include asm/neon-intrinsics.h rather than arm_neon.h
>   ARM: Remove hacked-up asm/types.h header

Applied patches 1-6 to
https://git.kernel.org/pub/scm/linux/kernel/git/ebiggers/linux.git/log/?h=crc-next

- Eric